// This file was auto-generated by Flurl.Http.CodeGen. Do not edit directly.
using System;
using System.Collections.Generic;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Threading;
using System.Threading.Tasks;
using Flurl.Http.Configuration;
using Flurl.Http.Content;

namespace Flurl.Http
{
	/// <summary>
	/// Auto-generated fluent extension methods on String, Url, and IFlurlRequest.
	/// </summary>
	public static class GeneratedExtensions
	{
		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="verb">The HTTP method used to make the request.</param>
		/// <param name="content">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> SendAsync(this Url url, HttpMethod verb, HttpContent content, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).SendAsync(verb, content, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="verb">The HTTP method used to make the request.</param>
		/// <param name="content">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> SendAsync(this string url, HttpMethod verb, HttpContent content, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).SendAsync(verb, content, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="verb">The HTTP method used to make the request.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> SendJsonAsync(this IFlurlRequest request, HttpMethod verb, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			var content = new CapturedJsonContent(request.Settings.JsonSerializer.Serialize(data));
			return request.SendAsync(verb, content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="verb">The HTTP method used to make the request.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> SendJsonAsync(this Url url, HttpMethod verb, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).SendJsonAsync(verb, data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="verb">The HTTP method used to make the request.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> SendJsonAsync(this string url, HttpMethod verb, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).SendJsonAsync(verb, data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="verb">The HTTP method used to make the request.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> SendStringAsync(this IFlurlRequest request, HttpMethod verb, string data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			var content = new CapturedStringContent(data);
			return request.SendAsync(verb, content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="verb">The HTTP method used to make the request.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> SendStringAsync(this Url url, HttpMethod verb, string data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).SendStringAsync(verb, data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="verb">The HTTP method used to make the request.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> SendStringAsync(this string url, HttpMethod verb, string data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).SendStringAsync(verb, data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="verb">The HTTP method used to make the request.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> SendUrlEncodedAsync(this IFlurlRequest request, HttpMethod verb, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			var content = new CapturedUrlEncodedContent(request.Settings.UrlEncodedSerializer.Serialize(data));
			return request.SendAsync(verb, content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="verb">The HTTP method used to make the request.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> SendUrlEncodedAsync(this Url url, HttpMethod verb, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).SendUrlEncodedAsync(verb, data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="verb">The HTTP method used to make the request.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> SendUrlEncodedAsync(this string url, HttpMethod verb, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).SendUrlEncodedAsync(verb, data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous GET request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> GetAsync(this IFlurlRequest request, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(HttpMethod.Get, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Sends an asynchronous GET request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the JSON response body deserialized to an object of type T.</returns>
		public static Task<T> GetJsonAsync<T>(this IFlurlRequest request, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(HttpMethod.Get, cancellationToken: cancellationToken, completionOption: completionOption).ReceiveJson<T>();
		}

		/// <summary>
		/// Sends an asynchronous GET request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the JSON response body deserialized to a dynamic.</returns>
		public static Task<dynamic> GetJsonAsync(this IFlurlRequest request, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(HttpMethod.Get, cancellationToken: cancellationToken, completionOption: completionOption).ReceiveJson();
		}

		/// <summary>
		/// Sends an asynchronous GET request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the JSON response body deserialized to a list of dynamics.</returns>
		public static Task<IList<dynamic>> GetJsonListAsync(this IFlurlRequest request, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(HttpMethod.Get, cancellationToken: cancellationToken, completionOption: completionOption).ReceiveJsonList();
		}

		/// <summary>
		/// Sends an asynchronous GET request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the response body as a string.</returns>
		public static Task<string> GetStringAsync(this IFlurlRequest request, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(HttpMethod.Get, cancellationToken: cancellationToken, completionOption: completionOption).ReceiveString();
		}

		/// <summary>
		/// Sends an asynchronous GET request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the response body as a Stream.</returns>
		public static Task<Stream> GetStreamAsync(this IFlurlRequest request, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(HttpMethod.Get, cancellationToken: cancellationToken, completionOption: completionOption).ReceiveStream();
		}

		/// <summary>
		/// Sends an asynchronous GET request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the response body as a byte array.</returns>
		public static Task<byte[]> GetBytesAsync(this IFlurlRequest request, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(HttpMethod.Get, cancellationToken: cancellationToken, completionOption: completionOption).ReceiveBytes();
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> GetAsync(this Url url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the JSON response body deserialized to an object of type T.</returns>
		public static Task<T> GetJsonAsync<T>(this Url url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetJsonAsync<T>(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the JSON response body deserialized to a dynamic.</returns>
		public static Task<dynamic> GetJsonAsync(this Url url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetJsonAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the JSON response body deserialized to a list of dynamics.</returns>
		public static Task<IList<dynamic>> GetJsonListAsync(this Url url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetJsonListAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the response body as a string.</returns>
		public static Task<string> GetStringAsync(this Url url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetStringAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the response body as a Stream.</returns>
		public static Task<Stream> GetStreamAsync(this Url url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetStreamAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the response body as a byte array.</returns>
		public static Task<byte[]> GetBytesAsync(this Url url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetBytesAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> GetAsync(this string url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the JSON response body deserialized to an object of type T.</returns>
		public static Task<T> GetJsonAsync<T>(this string url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetJsonAsync<T>(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the JSON response body deserialized to a dynamic.</returns>
		public static Task<dynamic> GetJsonAsync(this string url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetJsonAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the JSON response body deserialized to a list of dynamics.</returns>
		public static Task<IList<dynamic>> GetJsonListAsync(this string url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetJsonListAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the response body as a string.</returns>
		public static Task<string> GetStringAsync(this string url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetStringAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the response body as a Stream.</returns>
		public static Task<Stream> GetStreamAsync(this string url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetStreamAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous GET request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the response body as a byte array.</returns>
		public static Task<byte[]> GetBytesAsync(this string url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).GetBytesAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous POST request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="content">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PostAsync(this IFlurlRequest request, HttpContent content, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(HttpMethod.Post, content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous POST request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="content">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PostAsync(this Url url, HttpContent content, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PostAsync(content, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous POST request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="content">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PostAsync(this string url, HttpContent content, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PostAsync(content, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous POST request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PostJsonAsync(this IFlurlRequest request, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			var content = new CapturedJsonContent(request.Settings.JsonSerializer.Serialize(data));
			return request.SendAsync(HttpMethod.Post, content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous POST request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PostJsonAsync(this Url url, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PostJsonAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous POST request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PostJsonAsync(this string url, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PostJsonAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous POST request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PostStringAsync(this IFlurlRequest request, string data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			var content = new CapturedStringContent(data);
			return request.SendAsync(HttpMethod.Post, content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous POST request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PostStringAsync(this Url url, string data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PostStringAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous POST request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PostStringAsync(this string url, string data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PostStringAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous POST request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PostUrlEncodedAsync(this IFlurlRequest request, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			var content = new CapturedUrlEncodedContent(request.Settings.UrlEncodedSerializer.Serialize(data));
			return request.SendAsync(HttpMethod.Post, content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous POST request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PostUrlEncodedAsync(this Url url, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PostUrlEncodedAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous POST request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PostUrlEncodedAsync(this string url, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PostUrlEncodedAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous HEAD request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> HeadAsync(this IFlurlRequest request, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(HttpMethod.Head, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous HEAD request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> HeadAsync(this Url url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).HeadAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous HEAD request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> HeadAsync(this string url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).HeadAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous PUT request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="content">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PutAsync(this IFlurlRequest request, HttpContent content, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(HttpMethod.Put, content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous PUT request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="content">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PutAsync(this Url url, HttpContent content, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PutAsync(content, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous PUT request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="content">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PutAsync(this string url, HttpContent content, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PutAsync(content, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous PUT request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PutJsonAsync(this IFlurlRequest request, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			var content = new CapturedJsonContent(request.Settings.JsonSerializer.Serialize(data));
			return request.SendAsync(HttpMethod.Put, content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous PUT request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PutJsonAsync(this Url url, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PutJsonAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous PUT request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PutJsonAsync(this string url, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PutJsonAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous PUT request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PutStringAsync(this IFlurlRequest request, string data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			var content = new CapturedStringContent(data);
			return request.SendAsync(HttpMethod.Put, content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous PUT request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PutStringAsync(this Url url, string data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PutStringAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous PUT request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PutStringAsync(this string url, string data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PutStringAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous DELETE request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> DeleteAsync(this IFlurlRequest request, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(HttpMethod.Delete, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous DELETE request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> DeleteAsync(this Url url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).DeleteAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous DELETE request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> DeleteAsync(this string url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).DeleteAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous PATCH request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="content">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PatchAsync(this IFlurlRequest request, HttpContent content, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(new HttpMethod("PATCH"), content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous PATCH request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="content">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PatchAsync(this Url url, HttpContent content, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PatchAsync(content, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous PATCH request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="content">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PatchAsync(this string url, HttpContent content, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PatchAsync(content, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous PATCH request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PatchJsonAsync(this IFlurlRequest request, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			var content = new CapturedJsonContent(request.Settings.JsonSerializer.Serialize(data));
			return request.SendAsync(new HttpMethod("PATCH"), content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous PATCH request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PatchJsonAsync(this Url url, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PatchJsonAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous PATCH request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PatchJsonAsync(this string url, object data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PatchJsonAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous PATCH request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PatchStringAsync(this IFlurlRequest request, string data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			var content = new CapturedStringContent(data);
			return request.SendAsync(new HttpMethod("PATCH"), content: content, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous PATCH request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PatchStringAsync(this Url url, string data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PatchStringAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous PATCH request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="data">Contents of the request body.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> PatchStringAsync(this string url, string data, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).PatchStringAsync(data, cancellationToken, completionOption);
		}

		/// <summary>
		/// Sends an asynchronous OPTIONS request.
		/// </summary>
		/// <param name="request">The IFlurlRequest instance.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> OptionsAsync(this IFlurlRequest request, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return request.SendAsync(HttpMethod.Options, cancellationToken: cancellationToken, completionOption: completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous OPTIONS request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> OptionsAsync(this Url url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).OptionsAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a FlurlRequest from the URL and sends an asynchronous OPTIONS request.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cancellationToken">A cancellation token that can be used by other objects or threads to receive notice of cancellation. Optional.</param>
		/// <param name="completionOption">The HttpCompletionOption used in the request. Optional.</param>
		/// <returns>A Task whose result is the received HttpResponseMessage.</returns>
		public static Task<HttpResponseMessage> OptionsAsync(this string url, CancellationToken cancellationToken = default(CancellationToken), HttpCompletionOption completionOption = HttpCompletionOption.ResponseContentRead) {
			return new FlurlRequest(url).OptionsAsync(cancellationToken, completionOption);
		}

		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets a request header.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="name">The header name.</param>
		/// <param name="value">The header value.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithHeader(this Url url, string name, object value) {
			return new FlurlRequest(url).WithHeader(name, value);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets request headers based on property names/values of the provided object, or keys/values if object is a dictionary, to be sent
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="headers">Names/values of HTTP headers to set. Typically an anonymous object or IDictionary.</param>
		/// <param name="replaceUnderscoreWithHyphen">If true, underscores in property names will be replaced by hyphens. Default is true.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithHeaders(this Url url, object headers, bool replaceUnderscoreWithHyphen = true) {
			return new FlurlRequest(url).WithHeaders(headers, replaceUnderscoreWithHyphen);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets the Authorization header according to Basic Authentication protocol.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="username">Username of authenticating user.</param>
		/// <param name="password">Password of authenticating user.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithBasicAuth(this Url url, string username, string password) {
			return new FlurlRequest(url).WithBasicAuth(username, password);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets the Authorization header with a bearer token according to OAuth 2.0 specification.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="token">The acquired oAuth bearer token.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithOAuthBearerToken(this Url url, string token) {
			return new FlurlRequest(url).WithOAuthBearerToken(token);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and allows cookies to be sent and received. Not necessary to call when setting cookies via WithCookie/WithCookies.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest EnableCookies(this Url url) {
			return new FlurlRequest(url).EnableCookies();
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets an HTTP cookie to be sent
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cookie"></param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithCookie(this Url url, Cookie cookie) {
			return new FlurlRequest(url).WithCookie(cookie);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets an HTTP cookie to be sent.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="name">The cookie name.</param>
		/// <param name="value">The cookie value.</param>
		/// <param name="expires">The cookie expiration (optional). If excluded, cookie only lives for duration of session.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithCookie(this Url url, string name, object value, DateTime? expires = null) {
			return new FlurlRequest(url).WithCookie(name, value, expires);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets HTTP cookies to be sent, based on property names / values of the provided object, or keys / values if object is a dictionary.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cookies">Names/values of HTTP cookies to set. Typically an anonymous object or IDictionary.</param>
		/// <param name="expires">Expiration for all cookies (optional). If excluded, cookies only live for duration of session.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithCookies(this Url url, object cookies, DateTime? expires = null) {
			return new FlurlRequest(url).WithCookies(cookies, expires);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and allows changing its Settings inline.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="action">A delegate defining the Settings changes.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest ConfigureRequest(this Url url, Action<FlurlHttpSettings> action) {
			return new FlurlRequest(url).ConfigureRequest(action);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets the request timeout.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="timespan">Time to wait before the request times out.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithTimeout(this Url url, TimeSpan timespan) {
			return new FlurlRequest(url).WithTimeout(timespan);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets the request timeout.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="seconds">Seconds to wait before the request times out.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithTimeout(this Url url, int seconds) {
			return new FlurlRequest(url).WithTimeout(seconds);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and adds a pattern representing an HTTP status code or range of codes which (in addition to 2xx) will NOT result in a FlurlHttpException being thrown.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="pattern">Examples: "3xx", "100,300,600", "100-299,6xx"</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest AllowHttpStatus(this Url url, string pattern) {
			return new FlurlRequest(url).AllowHttpStatus(pattern);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and adds an HttpStatusCode which (in addtion to 2xx) will NOT result in a FlurlHttpException being thrown.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="statusCodes">The HttpStatusCode(s) to allow.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest AllowHttpStatus(this Url url, params HttpStatusCode[] statusCodes) {
			return new FlurlRequest(url).AllowHttpStatus(statusCodes);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and configures it to allow any returned HTTP status without throwing a FlurlHttpException.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest AllowAnyHttpStatus(this Url url) {
			return new FlurlRequest(url).AllowAnyHttpStatus();
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets a request header.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="name">The header name.</param>
		/// <param name="value">The header value.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithHeader(this string url, string name, object value) {
			return new FlurlRequest(url).WithHeader(name, value);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets request headers based on property names/values of the provided object, or keys/values if object is a dictionary, to be sent
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="headers">Names/values of HTTP headers to set. Typically an anonymous object or IDictionary.</param>
		/// <param name="replaceUnderscoreWithHyphen">If true, underscores in property names will be replaced by hyphens. Default is true.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithHeaders(this string url, object headers, bool replaceUnderscoreWithHyphen = true) {
			return new FlurlRequest(url).WithHeaders(headers, replaceUnderscoreWithHyphen);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets the Authorization header according to Basic Authentication protocol.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="username">Username of authenticating user.</param>
		/// <param name="password">Password of authenticating user.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithBasicAuth(this string url, string username, string password) {
			return new FlurlRequest(url).WithBasicAuth(username, password);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets the Authorization header with a bearer token according to OAuth 2.0 specification.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="token">The acquired oAuth bearer token.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithOAuthBearerToken(this string url, string token) {
			return new FlurlRequest(url).WithOAuthBearerToken(token);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and allows cookies to be sent and received. Not necessary to call when setting cookies via WithCookie/WithCookies.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest EnableCookies(this string url) {
			return new FlurlRequest(url).EnableCookies();
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets an HTTP cookie to be sent
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cookie"></param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithCookie(this string url, Cookie cookie) {
			return new FlurlRequest(url).WithCookie(cookie);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets an HTTP cookie to be sent.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="name">The cookie name.</param>
		/// <param name="value">The cookie value.</param>
		/// <param name="expires">The cookie expiration (optional). If excluded, cookie only lives for duration of session.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithCookie(this string url, string name, object value, DateTime? expires = null) {
			return new FlurlRequest(url).WithCookie(name, value, expires);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets HTTP cookies to be sent, based on property names / values of the provided object, or keys / values if object is a dictionary.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="cookies">Names/values of HTTP cookies to set. Typically an anonymous object or IDictionary.</param>
		/// <param name="expires">Expiration for all cookies (optional). If excluded, cookies only live for duration of session.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithCookies(this string url, object cookies, DateTime? expires = null) {
			return new FlurlRequest(url).WithCookies(cookies, expires);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and allows changing its Settings inline.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="action">A delegate defining the Settings changes.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest ConfigureRequest(this string url, Action<FlurlHttpSettings> action) {
			return new FlurlRequest(url).ConfigureRequest(action);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets the request timeout.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="timespan">Time to wait before the request times out.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithTimeout(this string url, TimeSpan timespan) {
			return new FlurlRequest(url).WithTimeout(timespan);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and sets the request timeout.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="seconds">Seconds to wait before the request times out.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest WithTimeout(this string url, int seconds) {
			return new FlurlRequest(url).WithTimeout(seconds);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and adds a pattern representing an HTTP status code or range of codes which (in addition to 2xx) will NOT result in a FlurlHttpException being thrown.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="pattern">Examples: "3xx", "100,300,600", "100-299,6xx"</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest AllowHttpStatus(this string url, string pattern) {
			return new FlurlRequest(url).AllowHttpStatus(pattern);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and adds an HttpStatusCode which (in addtion to 2xx) will NOT result in a FlurlHttpException being thrown.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <param name="statusCodes">The HttpStatusCode(s) to allow.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest AllowHttpStatus(this string url, params HttpStatusCode[] statusCodes) {
			return new FlurlRequest(url).AllowHttpStatus(statusCodes);
		}
		/// <summary>
		/// Creates a new FlurlRequest with the URL and configures it to allow any returned HTTP status without throwing a FlurlHttpException.
		/// </summary>
		/// <param name="url">The URL.</param>
		/// <returns>The IFlurlRequest.</returns>
		public static IFlurlRequest AllowAnyHttpStatus(this string url) {
			return new FlurlRequest(url).AllowAnyHttpStatus();
		}
	}
}
